--
-- TenderAttacher
--
-- @author  Manuel Leithner
-- @date  05/10/17
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

TenderAttacher = {}

function TenderAttacher.prerequisitesPresent(specializations)
    return true
end

function TenderAttacher:load(savegame)
    self.tenderAttacher = {}
    self.tenderAttacher.nodes = {}
    self.tenderAttacher.currentNode = nil
    local i = 0
    while true do
        local key = string.format("vehicle.tenderAttachers.tenderAttacher(%d)", i)
        if not hasXMLProperty(self.xmlFile, key) then
            break
        end

        local node = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#node"))
        local vehicleXMLPath = getXMLString(self.xmlFile, key.."#vehicleXMLPath")

        if node ~= nil and vehicleXMLPath ~= nil then
            vehicleXMLPath = Utils.convertToNetworkFilename(vehicleXMLPath)
            self.tenderAttacher.nodes[vehicleXMLPath] = node
            setVisibility(node, false)
        end

        i = i + 1
    end
end

function TenderAttacher:delete()
end

function TenderAttacher:mouseEvent(posX, posY, isDown, isUp, button)
end

function TenderAttacher:keyEvent(unicode, sym, modifier, isDown)
end

function TenderAttacher:update(dt)
end

function TenderAttacher:draw()
end

function TenderAttacher:onAttach(attacherVehicle, jointDescIndex)
    local xmlPath = Utils.convertToNetworkFilename(attacherVehicle.configFileName)
    local node = self.tenderAttacher.nodes[xmlPath]
    if node ~= nil then
        setVisibility(node, true)
    end
    self.tenderAttacher.currentNode = node

    local jointDesc = attacherVehicle.attacherJoints[jointDescIndex]
    self.enableCollisionBackup = jointDesc.enableCollision
    jointDesc.enableCollision = false
end

function TenderAttacher:onDetach(attacherVehicle, jointDescIndex)
    if self.tenderAttacher.currentNode ~= nil then
        setVisibility(self.tenderAttacher.currentNode, false)
    end

    local jointDesc = attacherVehicle.attacherJoints[jointDescIndex]
    jointDesc.enableCollision = self.enableCollisionBackup
end
